//Originally the Sonic Lost World Bounce Attack by MotdSpork. Boing!
local function CheckAndCrumble(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end

addHook("MobjThinker", function(king)
	if (king and king.skin == "king") //if you're king...
	and king.player.playerstate == PST_LIVE //you alive bruh?
	and not (king.player.powers[pw_super] > 0)
	and not (king.player.powers[pw_carry])
		if king.player.bounceattack == nil //if the variable doesnt exist
			king.player.bounceattack = 0 //create variable
		end
		if king.player.bouncenumber == nil //if the variable doesnt exist
			king.player.bouncenumber = 0 //create variable
			king.player.justchangedbouncenumber = 0 //create variable
		end
		if P_IsObjectOnGround(king) //are you on the ground?
		and king.player.bounceattack == 0 //the player isnt bouncing
			king.player.bouncenumber = 0 //set it to zero!
		end
		if king.player.usedown == nil //if the variable doesnt exist
		or not (king.player.cmd.buttons & BT_USE) //not pressing the spin button?
			king.player.usedown = 0 //create variable
			king.player.justchangedbouncenumber = 0 //create variable
		end
		if P_IsObjectOnGround(king) //Is the player on the ground?
		and (king.player.cmd.buttons & BT_USE) //Is the player holding the spin button?
			king.player.usedown = 1 //Set it to one!
		end
		if king.player.pflags & PF_JUMPED //if the player has jumped
		and not (P_IsObjectOnGround(king)) //and you arent on the ground.
		and king.player.cmd.buttons & BT_USE //pressing custom2?
		and king.player.bounceattack == 0 //checking if the custom variable it set to 0
		and king.player.usedown == 0 //make sure you arent holding the spin button.
		and not (king.player.exiting) //not...exiting the level?
		and king.health //you're alive?
		and not (P_PlayerInPain(king.player)) //not hurt are you?
			king.player.bounceattack = 1 //set it to one!
			P_SetObjectMomZ(king, -28*FRACUNIT) //make the player "shoot" downward
			//P_SetObjectMomZ(king, FixedMul(-35*FRACUNIT, king.scale)) //make the player shoot downwards 
			king.player.pflags = $1|PF_THOKKED //force the player into a "thokked" state
		end

		if (king.eflags & MFE_JUSTHITFLOOR) //you're on the ground.
		and not (king.player.pflags & PF_SPINNING) //you arent spinning....somehow
		and not (king.player.pflags & PF_STARTDASH) //you arent doing a spindash
		and not (king.tracer and king.tracer.type == MT_TUBEWAYPOINT) //not in a...zoomtube?
		and king.player.bounceattack == 1 //our custom variable is one right...?
		and king.health //is the player alive..?
		and not (P_PlayerInPain(king.player)) //not hurt are you?
			if king.player.bouncenumber == 0 //if he hasnt bounced yet
			and king.player.justchangedbouncenumber == 0 //if he hasnt left the ground yet
				king.player.justchangedbouncenumber = 1 //now he has!
				king.player.bouncenumber = 1 //Set this to one!
				king.player.pflags = $1|PF_JUMPED //forcing the player into a jumping state.
				P_SetObjectMomZ(king, 15*FRACUNIT)
				if not (king.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
					king.state = S_PLAY_ROLL //force the player into a spinning state.
				end
			end
			if king.player.bouncenumber == 1 //if it's currently on his first bounce
			and king.player.justchangedbouncenumber == 0 //if he hasnt left the ground yet
			and not (P_PlayerInPain(king.player)) //not hurt are you?
				king.player.justchangedbouncenumber = 1 //now he has!
				king.player.bouncenumber = 1 //set this to one!
				king.player.pflags = $1|PF_JUMPED //forcing the player into a jumping state.
				P_SetObjectMomZ(king, 15*FRACUNIT)
				if not (king.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
					king.state = S_PLAY_ROLL //force the player into a spinning state.
				end
			end
			king.player.bounceattack = 0 //set it to zero.
			king.player.usedown = 1 //set it to one.
			king.player.pflags = $1 & ~PF_THOKKED //uncheck the thokked flag, allowing you to bounce again.
			CheckAndCrumble(king, king.subsector.sector)
			S_StartSound(king, sfx_s3k44) //play a sound c:
			for i = 0, 8
				local fa = (i*(ANGLE_180/4))
				local dust = P_SpawnMobj(king.x, king.y, king.z, MT_SPINDUST)
				dust.momx = FixedMul(sin(fa),10*FRACUNIT)
				dust.momy = FixedMul(cos(fa),10*FRACUNIT)
			end
		end
		//some quick checks

		if king.player.bounceattack == 1 //checking our variable.
		and king.health //and you're alive
		and not (P_PlayerInPain(king.player)) //not hurt are you?
			P_SpawnThokMobj(king.player) //spawn the players thok object
			if not (king.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
				king.state = S_PLAY_ROLL //force the player into a spinning state.
				if king.eflags & MFE_GOOWATER
					king.state = S_PLAY_RIDE
				end
			end
			if (king.momz > (9000*P_MobjFlip(king))) // the player is going up...?  
				P_SetObjectMomZ(king, FixedMul(-35*FRACUNIT, king.scale)) //not anymore >.>
			end
		else 
			king.player.bounceattack = 0 //set it to 0
		end
		if king.player.bounceattack == 1 //checking if hes bouncing
			king.player.pflags = $1 & ~PF_SPINNING // you're no longer "spinning" if you were before
		end
		if not (king.player.pflags & PF_JUMPED) // if you are not actuallly jumping
			king.player.bounceattack = 0 //set this back to zero to be safe
		end
		
		if king.eflags & MFE_GOOWATER //is the player in THZ goop?
			king.player.bounceattack = 0 //set to zero!
		end
		if not (king.player.pflags & PF_JUMPED) //if the player hasnt jumped
			king.player.bounceattack = 0 //set this to zero
		end
	end
end, MT_PLAYER)