freeslot("sfx_bruh", "sfx_bwmp", "sfx_vnbm", "sfx_ohmg")

local function CheckAndCrumble(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end

addHook("PlayerThink", function(p)
if not (p and p.mo and p.mo.valid and p.mo.skin == "king") then return end

  p.c1held = $ or false
  p.c2held = $ or false
  p.c3held = $ or false
  p.flagheld = $ or false

  if (p.cmd.buttons & BT_CUSTOM1)
  or (p.cmd.buttons & BT_CUSTOM2)
  or (p.cmd.buttons & BT_CUSTOM3)
  or (p.cmd.buttons & BT_TOSSFLAG) then
    local sound
    if (p.cmd.buttons & BT_CUSTOM1) and not p.c1held then
      sound = sfx_bruh
      p.c1held = true
    elseif (p.cmd.buttons & BT_CUSTOM2) and not p.c2held then
      sound = sfx_bwmp
	  p.c2held = true
    elseif (p.cmd.buttons & BT_CUSTOM3) and not p.c3held then
      sound = sfx_vnbm
      p.c3held = true
    elseif (p.cmd.buttons & BT_TOSSFLAG) and not p.flagheld then
      sound = sfx_ohmg
      p.flagheld = true
    end
    if sound then
	  S_StartSound(p.mo, sound)
	  local dist = P_SpawnMobjFromMobj(p.mo, cos(p.mo.angle)*32, sin(p.mo.angle)*32, p.height/2, MT_BRUH)
	  dist.fuse = 16
	  dist.refplayer = p
	  if (p.powers[pw_shield] & SH_NOSTACK == SH_ARMAGEDDON) then
	    P_BlackOw(p)
	  end
	  if (p.powers[pw_shield] & SH_NOSTACK == SH_WHIRLWIND) or (p.powers[pw_shield] & SH_NOSTACK == SH_THUNDERCOIN) then
		if p.pflags & PF_JUMPED or p.pflags & PF_THOKKED then
		  P_DoJumpShield(p)
		  p.pflags = $ | PF_SHIELDABILITY
		end
	  end
    end
  else
    p.c1held = false
    p.c2held = false
    p.c3held = false
    p.flagheld = false
  end
end)

addHook("MobjThinker", function(mo)
    local dist = 32 -- Let's assume you want it floating 32 pixels in front of the player
    -- Start by calculating the new offsets for that frame
    mo.angle = mo.refplayer.mo.angle
	CheckAndCrumble(mo, mo.subsector.sector)
	local offx = cos(mo.refplayer.mo.angle)*dist -- Cosine of player angle times the distance
    local offy = sin(mo.refplayer.mo.angle)*dist -- Sine of the player angle times the distance
    -- Now teleport the object there
    P_TeleportMove(mo, mo.refplayer.mo.x+offx, mo.refplayer.mo.y+offy, mo.refplayer.mo.z+8*FRACUNIT)
end, MT_BRUH)

local function KING_SpeakerCollision(speak, collide)
    -- Collision! We first need to check the heights, however.
    if speak.z < collide.z+collide.height -- This checks if we have passed above the collided object.
    and speak.z+speak.height > collide.z -- This checks if we have passed below the collided object.
        -- We have confirmed that we have collided with the object now.
        if collide.flags & MF_ENEMY|MF_MONITOR -- Is it an enemy and/or monitor?
            P_DamageMobj(collide, speak, speak.refplayer.mo) -- Damage.
		end
	end
end

addHook ("MobjMoveCollide", function (meme, mo)
	if meme.type == MT_BRUH
		if (mo.type == MT_SPIKE
		or mo.type == MT_WALLSPIKE)
			if (meme.z + meme.height < mo.z) 
			or (meme.z > mo.z + mo.height)
				return false
			else
				P_KillMobj(mo,meme,meme)
			end
		end
	end
end)

addHook("MobjCollide", KING_SpeakerCollision, MT_BRUH)
addHook("MobjMoveCollide", KING_SpeakerCollision, MT_BRUH)